deferred class TAG_SINGLETON
feature
    tag_table : DICTIONARY[TAG, STRING] is
    once
	!!Result.make
    end

    size_tag_array : ARRAY[TAG] is
    once
	!!Result.make(0, 9)
    end

    color_tag_array : ARRAY[TAG] is
    once
	!!Result.make(1, 8)
    end

    opposite_tag(t : TAG) : TAG is
    do
	if t.tag_start then
	    Result := tag_table.at("/" + t.name)
	else
	    Result := tag_table.at(t.name)
	end
    end

    init_tag_table is
    local
	c : CHARACTER
	i : INTEGER
	t : TAG
    do
	--yuk
	!B_TAG!t.make(True)
	!B_TAG!t.make(False)
	!I_TAG!t.make(True)
	!I_TAG!t.make(False)
	!TT_TAG!t.make(True)
	!TT_TAG!t.make(False)
	!U_TAG!t.make(True)
	!U_TAG!t.make(False)
	!S_TAG!t.make(True)
	!S_TAG!t.make(False)
	!EM_TAG!t.make(True)
	!EM_TAG!t.make(False)
	!PL_TAG!t.make(True)
	!PL_TAG!t.make(False)
	from i := 0
	until i > 9
	loop
	    !SIZE_TAG!t.make_size(i, True)
	    size_tag_array.put(t, i)
	    !SIZE_TAG!t.make_size(i, False)
	    i := i + 1
	end

	from i := 1
	until i > 8
	loop
	    c := ("rgbcmykw").item(i)
	    !COLOR_TAG!t.make_color(c, True)
	    color_tag_array.put(t, i)
	    !COLOR_TAG!t.make_color(c, False)
	    i := i + 1
	end
    end

    b_tag : TAG is
    once
	Result := tag_table.at("B")
    end

    s_tag : TAG is
    once
	Result := tag_table.at("S")
    end

    i_tag : TAG is
    once
	Result := tag_table.at("I")
    end

    u_tag : TAG is
    once
	Result := tag_table.at("U")
    end

    tt_tag : TAG is
    once
	Result := tag_table.at("TT")
    end

    pl_tag : TAG is
    once
	Result := tag_table.at("PL")
    end

    em_tag : TAG is
    once
	Result := tag_table.at("EM")
    end

    is_start_color_tag(t : TAG) : BOOLEAN is
    do
	Result := color_tag_array.fast_has(t)
    end

    is_start_size_tag(t : TAG) : BOOLEAN is
    do
	Result := size_tag_array.fast_has(t)
    end
end
