class CONTEXT
creation make, make_from
feature
    make is
    do
	--by default, all flags = false, ints = 0, pointers = Void
    end

    make_from(c : like Current) is
    do
	b_flag := c.b_flag
	i_flag := c.i_flag
	s_flag := c.s_flag
	em_flag := c.em_flag
	tt_flag := c.tt_flag
	u_count := c.u_count
	size := c.size
	color := c.color
    end

    b_flag : BOOLEAN
    em_flag : BOOLEAN
    s_flag : BOOLEAN
    i_flag : BOOLEAN
    tt_flag : BOOLEAN
    u_count : INTEGER
    size : SIZE_TAG
    color : COLOR_TAG

    set_b_flag is
    do
	b_flag := True
    end

    set_i_flag is
    do
	i_flag := True
    end

    set_s_flag_and_unset_em_flag is
    do
	s_flag := True
	em_flag := False
    end

    set_tt_flag is
    do
	tt_flag := True
    end

    invert_em_flag is
    --require
	--not s_flag
    do
	em_flag := not em_flag
    end

    increment_u_count is
    --require
	--u_count < 3
    do
	u_count := u_count + 1
    end

    put_size(s : SIZE_TAG) is
    do
	size := s
    end

    put_color(c : COLOR_TAG) is
    do
	color := c
    end

    do_pl is
    do
	s_flag := False
	em_flag := False
	i_flag := False
	b_flag := False
	tt_flag := False
	u_count := 0
    ensure
	pl_done
    end

    pl_done : BOOLEAN is
    do
	if not s_flag then
	    if not em_flag then
		if not i_flag then
		    if not b_flag then
			if not tt_flag then
			    if u_count = 0 then
				Result := True
			    end
			end
		    end
		end
	    end
	end
    end

    error_out_flag(f : BOOLEAN) is
    do
	if f then
	    std_error.put_character('+')
	else
	    std_error.put_character('-')
	end
    end

    show_info is
    do
	error_out_flag(b_flag)
	--io.put_string("B ")
	error_out_flag(i_flag)
	--io.put_string("I ")
	error_out_flag(s_flag)
	--io.put_string("S ")
	error_out_flag(em_flag)
	--io.put_string("EM ")
	error_out_flag(tt_flag)
	--io.put_string("TT ")
	--io.put_string("U=")
	std_error.put_integer(u_count)
	--io.put_string(" ")
	--io.put_string("size=")
	if size = Void then
	    std_error.put_string("R")
	else
	    std_error.put_integer(size.size)
	end
	--io.put_string(" ")
	--io.put_string("color=")
	if color = Void then
	    std_error.put_string("R")
	else
	    std_error.put_character(color.color)
	end
    end

    dump_ws is
    do
	dump_flag(False)
	dump_flag(False)
	dump_flag(False)
	dump_flag(False)
	dump_flag(tt_flag)
	io.put_integer(u_count)
	if size = Void then
	    io.put_string("R")
	else
	    io.put_integer(size.size)
	end
	if u_count = 0 then
	    io.put_character('w')
	else
	    if color = Void then
		io.put_string("R")
	    else
		io.put_character(color.color)
	    end
	end
    end

    dump is
    do
	dump_flag(b_flag)
	dump_flag(i_flag)
	dump_flag(s_flag)
	dump_flag(em_flag)
	dump_flag(tt_flag)
	io.put_integer(u_count)
	if size = Void then
	    io.put_string("R")
	else
	    io.put_integer(size.size)
	end
	if color = Void then
	    io.put_string("R")
	else
	    io.put_character(color.color)
	end
    end

    dump_flag(f : BOOLEAN) is
    do
	if f then
	    io.put_character('1')
	else
	    io.put_character('0')
	end
    end
end
