deferred class TAG
inherit TAG_SINGLETON
feature
    tag_start : BOOLEAN

    code : INTEGER

    make(open : BOOLEAN) is
    do
	tag_start := open
	if tag_start then
	    tag_table.put(Current, name)
	    length := name.count + 2
	else
	    tag_table.put(Current, "/" + name)
	    length := name.count + 3
	end
    end

    length : INTEGER

    execute(c : CONTEXT) is
    deferred
    end

    is_redundant(c : CONTEXT) : BOOLEAN is
    deferred
    end

    output is
    do
	io.put_character('<')
	if not tag_start then
	    io.put_character('/')
	end
	io.put_string(name)
	io.put_character('>')
    end

    error_out is
    do
	std_error.put_character('<')
	if not tag_start then
	    std_error.put_character('/')
	end
	std_error.put_string(name)
	std_error.put_character('>')
    end

    name : STRING is
    deferred
    end
end
